# Client Class Reference

Thread that runs the User Interface. More...

`#include <yatecbase.h>`

Inheritance diagram for Client:

List of all members.

## Public Member Functions

| Client (const char *name=0)
virtual void | run ()
virtual void | main ()=0
virtual void | lock ()=0
virtual void | unlock ()=0
void | lockOther ()
void | unlockOther ()
virtual void | allHidden ()=0
virtual bool | createWindow (const String &name)=0
virtual bool | addToLog (const String &text, Window *wnd=0)
virtual bool | setStatus (const String &text, Window *wnd=0)
bool | addToLogLocked (const String &text, Window *wnd=0)
bool | setStatusLocked (const String &text, Window *wnd=0)
virtual bool | action (Window *wnd, const String &name)
virtual bool | toggle (Window *wnd, const String &name, bool active)
virtual bool | select (Window *wnd, const String &name, const String &item, const String &text=String::empty())
virtual bool | callRouting (const String &caller, const String &called, Message *msg=0)
virtual bool | callIncoming (const String &caller, const String &dest=String::empty(), Message *msg=0)
virtual void | updateCDR (const Message &msg)
void | clearActive (const String &id)
void | callAccept (const char *callId=0)
void | callReject (const char *callId=0)
void | callHangup (const char *callId=0)
bool | callStart (const String &target, const String &line=String::empty(), const String &proto=String::empty(), const String &account=String::empty())
bool | emitDigit (char digit)
bool | oneThread () const
int | line () const
void | line (int newLine)
bool | hasElement (const String &name, Window *wnd=0, Window *skip=0)
bool | setActive (const String &name, bool active, Window *wnd=0, Window *skip=0)
bool | setFocus (const String &name, bool select=false, Window *wnd=0, Window *skip=0)
bool | setShow (const String &name, bool visible, Window *wnd=0, Window *skip=0)
bool | setText (const String &name, const String &text, Window *wnd=0, Window *skip=0)
bool | setCheck (const String &name, bool checked, Window *wnd=0, Window *skip=0)
bool | setSelect (const String &name, const String &item, Window *wnd=0, Window *skip=0)
bool | setUrgent (const String &name, bool urgent, Window *wnd=0, Window *skip=0)
bool | hasOption (const String &name, const String &item, Window *wnd=0, Window *skip=0)
bool | addOption (const String &name, const String &item, bool atStart, const String &text=String::empty(), Window *wnd=0, Window *skip=0)
bool | delOption (const String &name, const String &item, Window *wnd=0, Window *skip=0)
bool | addTableRow (const String &name, const String &item, const NamedList *data=0, bool atStart=false, Window *wnd=0, Window *skip=0)
bool | delTableRow (const String &name, const String &item, Window *wnd=0, Window *skip=0)
bool | setTableRow (const String &name, const String &item, const NamedList *data, Window *wnd=0, Window *skip=0)
bool | getTableRow (const String &name, const String &item, NamedList *data=0, Window *wnd=0, Window *skip=0)
bool | clearTable (const String &name, Window *wnd=0, Window *skip=0)
bool | getText (const String &name, String &text, Window *wnd=0, Window *skip=0)
bool | getCheck (const String &name, bool &checked, Window *wnd=0, Window *skip=0)
bool | getSelect (const String &name, String &item, Window *wnd=0, Window *skip=0)
void | moveRelated (const Window *wnd, int dx, int dy)
bool | initialized () const
const String & | activeId () const
void | idleActions ()

## Static Public Member Functions

static Client * | self ()
static bool | changing ()
static Window * | getWindow (const String &name)
static bool | setVisible (const String &name, bool show=true)
static bool | getVisible (const String &name)
static bool | openPopup (const String &name, const NamedList *params=0, const Window *parent=0)
static bool | openMessage (const char *text, const Window *parent=0, const char *context=0)
static bool | openConfirm (const char *text, const Window *parent=0, const char *context=0)
static ObjList * | listWindows ()

## Protected Member Functions

virtual void | loadWindows ()=0
virtual void | initWindows ()
virtual void | initClient ()
virtual void | exitClient ()
virtual void | setChannelDisplay (ClientChannel *chan)
virtual bool | updateCallHist (const NamedList &params)
void | addChannel (ClientChannel *chan)
void | delChannel (ClientChannel *chan)
void | setChannel (ClientChannel *chan)
void | setChannelInternal (ClientChannel *chan)
void | selectChannel (ClientChannel *chan, bool force=false)
void | updateFrom (const String &id)
void | updateFrom (const ClientChannel *chan)
void | enableAction (const ClientChannel *chan, const String &action)
bool | needProxy () const
bool | driverLockLoop ()

## Static Protected Member Functions

static bool | driverLock (long maxwait=0)
static void | driverUnlock ()

## Protected Attributes

ObjList | m_windows
String | m_activeId
bool | m_initialized
int | m_line
bool | m_oneThread
bool | m_multiLines
bool | m_autoAnswer

## Static Protected Attributes

static Client * | s_client
static int | s_changing

## Friends

class | Window
class | ClientChannel
class | ClientDriver

## Detailed Description

Thread that runs the User Interface.

Singleton class that holds the User Interface's main thread and methods

## Member Function Documentation

virtual void run | ( |  | ) | `[virtual]`

This method is called in another thread to do the actual job. When it returns the job or thread terminates.

Implements Runnable.

The documentation for this class was generated from the following file:

- yatecbase.h